package cofh.thermal.expansion.compat.jei.machine;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cofh.core.util.helpers.ItemHelper;
import cofh.lib.util.helpers.StringHelper;
import cofh.thermal.core.ThermalCore;
import cofh.thermal.core.compat.jei.TCoreJeiPlugin;
import cofh.thermal.core.util.managers.machine.PulverizerRecipeManager;
import cofh.thermal.core.util.recipes.machine.PulverizerRecipe;
import cofh.thermal.expansion.client.gui.machine.MachinePulverizerScreen;
import cofh.thermal.lib.compat.jei.Drawables;
import cofh.thermal.lib.compat.jei.ThermalRecipeCategory;
import cofh.thermal.lib.util.recipes.ThermalRecipe;
import com.mojang.blaze3d.vertex.PoseStack;
import java.util.ArrayList;
import java.util.List;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import mezz.jei.api.gui.builder.IRecipeSlotBuilder;
import mezz.jei.api.gui.drawable.IDrawable;
import mezz.jei.api.gui.drawable.IDrawableAnimated;
import mezz.jei.api.gui.ingredient.IRecipeSlotsView;
import mezz.jei.api.helpers.IGuiHelper;
import mezz.jei.api.recipe.IFocusGroup;
import mezz.jei.api.recipe.RecipeIngredientRole;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.level.block.Block;

public class PulverizerRecipeCategory extends ThermalRecipeCategory<PulverizerRecipe> {
  public PulverizerRecipeCategory(IGuiHelper guiHelper, ItemStack icon, ResourceLocation uid) {
    super(guiHelper, icon, uid);
    this
      
      .background = (IDrawable)guiHelper.drawableBuilder(MachinePulverizerScreen.TEXTURE, 26, 11, 124, 62).addPadding(0, 0, 16, 24).build();
    this.name = (Component)StringHelper.getTextComponent(((Block)ThermalCore.BLOCKS.get("machine_pulverizer")).m_7705_());
    this.progressBackground = Drawables.getDrawables(guiHelper).getProgress(0);
    this.speedBackground = Drawables.getDrawables(guiHelper).getScale(3);
    this.progress = guiHelper.createAnimatedDrawable(Drawables.getDrawables(guiHelper).getProgressFill(0), 200, IDrawableAnimated.StartDirection.LEFT, false);
    this.speed = guiHelper.createAnimatedDrawable(Drawables.getDrawables(guiHelper).getScaleFill(3), 400, IDrawableAnimated.StartDirection.TOP, true);
  }
  
  public Class<? extends PulverizerRecipe> getRecipeClass() {
    return PulverizerRecipe.class;
  }
  
  public void setRecipe(IRecipeLayoutBuilder builder, PulverizerRecipe recipe, IFocusGroup focuses) {
    List<Ingredient> inputs = recipe.getInputItems();
    List<ItemStack> outputs = new ArrayList<>(recipe.getOutputItems().size());
    List<ItemStack> catalysts = PulverizerRecipeManager.instance().getCatalysts();
    for (ItemStack stack : recipe.getOutputItems())
      outputs.add(ItemHelper.cloneStack(stack)); 
    for (int i = 0; i < outputs.size(); i++) {
      float chance = ((Float)recipe.getOutputItemChances().get(i)).floatValue();
      if (chance > 1.0F)
        ((ItemStack)outputs.get(i)).m_41764_((int)chance); 
    } 
    IRecipeSlotBuilder[] outputSlots = new IRecipeSlotBuilder[4];
    builder.addSlot(RecipeIngredientRole.INPUT, 34, 6)
      .addIngredients(inputs.get(0));
    IRecipeSlotBuilder catalystSlot = builder.addSlot(RecipeIngredientRole.INPUT, 34, 42);
    if (recipe.isCatalyzable())
      ((IRecipeSlotBuilder)catalystSlot.addItemStacks(catalysts))
        .addTooltipCallback(TCoreJeiPlugin.catalystTooltip()); 
    outputSlots[0] = builder.addSlot(RecipeIngredientRole.OUTPUT, 97, 15);
    outputSlots[1] = builder.addSlot(RecipeIngredientRole.OUTPUT, 115, 15);
    outputSlots[2] = builder.addSlot(RecipeIngredientRole.OUTPUT, 97, 33);
    outputSlots[3] = builder.addSlot(RecipeIngredientRole.OUTPUT, 115, 33);
    for (int j = 0; j < outputs.size(); j++)
      ((IRecipeSlotBuilder)outputSlots[j].addItemStack(outputs.get(j)))
        .addTooltipCallback(TCoreJeiPlugin.catalyzedOutputTooltip(((Float)recipe.getOutputItemChances().get(j)).floatValue(), recipe.isCatalyzable())); 
  }
  
  public void draw(PulverizerRecipe recipe, IRecipeSlotsView recipeSlotsView, PoseStack matrixStack, double mouseX, double mouseY) {
    super.draw((ThermalRecipe)recipe, recipeSlotsView, matrixStack, mouseX, mouseY);
    this.progressBackground.draw(matrixStack, 62, 24);
    this.speedBackground.draw(matrixStack, 34, 24);
    this.progress.draw(matrixStack, 62, 24);
    this.speed.draw(matrixStack, 34, 24);
  }
}
